# include "includes.h"

/***************************************************************************/
/* Define sequence subsets - only works for 1-99 sequences per subset!!!   */
/***************************************************************************/

void unicalc(bloc,cl,intcons,same,count,nbloc,ptype,
           gcut,neg,point,atyp,consval,resipos)

int **intcons,**same;
int count,gcut,neg,point,atyp,nbloc,consval;
struct slist ptype;
struct seqdat *bloc;
struct indclust *cl;
struct resisto *resipos;
{
  char **rN;
  int  *zto,noclust;
  int  nl,ny,mn,ml,mu,mx,fla,flb,sync,zno,ma;

  noclust=1;

/***************************************************************************/
/*         allocate structure to store conservation value returns          */
/***************************************************************************/

  zto=(int*) malloc (sizeof(int)*(count+3));

/* used normally to store ignored residue list - here used only as a dummy */

  rN = (char**) malloc (sizeof(char*)*(count+1));
  for(nl=1;nl<count+1;++nl)
    rN[nl]=(char*) malloc(sizeof(char)*(ptype.syno));

/**************************************************************************/
/*  Generate data for plot...                                             */
/**************************************************************************/

  sync=-1;
  printf("Execution: calculating conservation values...\n");



/**************************************************************************/
/*This loop will only activate if the number of clusters is greater than 1*/
/*This is because the loop condition is that mn must be less than noclust */
/*but mn starts at 1, so when noclust is 1 mn is never less than it       */
/**************************************************************************/

  
  for(mu=1;mu<count+3;++mu)zto[mu]=-1; 
  for(mu=1;mu<count+1;++mu)
    for(ny=0;ny<ptype.syno;++ny)rN[mu][ny]=-1;
  

/* calculate conservation values across whole alignment */

  zvel(zto,bloc,cl[1].number,cl[1].order,count,ptype,gcut,neg,
       point,nbloc,atyp,1,rN,resipos,1);

  for(mu=0;mu<count+1;++mu)intcons[1][mu]=zto[mu];
  for(mu=1;mu<count+1;++mu)if(zto[mu]>point)zto[mu]=point; 



/*
  for(ma=1;ma<nbloc+1;ma++){
    for(mu=1;mu<count+1;mu++)
      printf("%5c",bloc[ma].seq[mu]);
    printf("\n");
  }
 */


  for(mu=1;mu<count+1;++mu){
             
/* determine how many gaps are in the sequences */
/* (should this be here at all?!!)              */
                   
    fla=0;
    for(mx=1;mx<cl[1].number+1;++mx)
      if(bloc[cl[1].order[mx]].seq[mu]==' ')fla++;
                 
                 
/* if the number of gaps is equal to the number of sequences in a subgroup */
/* or the conservation value of the subgroup is less than the conservation */
/* cutoff, set the conservation value to a null value - the sub-group will */
/* be ignored								   */
                  
    if((fla>=cl[1].number)||(zto[mu]<consval))zto[mu]=-1;
                  
/* "same" array used to store processed whole sequence conservation pattern */
               
    same[1][mu]=zto[mu];
               
/* diff not used  */
             
/*    printf("%5d",zto[mu]); */      

  }
  
/**************************************************************************/
/*  free memory                                                           */
/**************************************************************************/

  free((char*) zto); 
  for(nl=1;nl<count+1;++nl)free((char*) rN[nl]);
  free((char*) rN);
}
